if (typeof window !== 'undefined') {
  window.sendRequest = function(method, url, data, headers) {
    var xhr = new XMLHttpRequest();
    var json = JSON.stringify(data);

    xhr.open(method, url);

    if (method === 'POST') {
      xhr.setRequestHeader('Content-type', 'application/json');
    }

    for (var h in headers) {
      var header = headers[h];
      xhr.setRequestHeader(header.key, header.value);
    }

    xhr.send(json);

    xhr.onload = function() {
      if (xhr.status !== 200) { // analyze HTTP status of the response
        console.log('Error ' + xhr.status + ': ' + xhr.statusText); // e.g. 404: Not Found
      }
      return;
    };
  };

  window.base64Encode = function(data) {
    var encodedData = window.btoa(data);
    return(encodedData);
  };

  window.jsonEncode = function(data) {
    var encodedData = JSON.stringify(data);
    return(encodedData);
  };
}

module.exports = {
  sendRequest: sendRequest,
  base64Encode: base64Encode,
  jsonEncode: jsonEncode
};
